
Name: mailgraph
Version: 1.8
Release: alt1

Summary: Simple mail statistics for Postfix
License: GPL
Group: Monitoring

Url: http://people.ee.ethz.ch/~dws/software/mailgraph
Source0: %url/pub/%name-%version.tar.bz2
Source1: %name.conf
Source2: localhost.htaccess
Source3: %name.init-Master
Source4: %name.init-Sisyphus
Patch0: %name-1.3-alt.patch

PreReq: /sbin/chkconfig
PreReq: grep

Requires: postfix
Requires: perl-File-Tail
Requires: rrd-perl
Requires: apache-mod_perl

# ugly hack
# Automatically added by buildreq on Tue Jan 20 2004 (-bi)
BuildRequires: XFree86-libs freetype2 perl-File-Tail rrd-perl xpm

BuildRequires: rrd-perl perl-File-Tail

BuildArch: noarch

Summary(ru_RU.KOI8-R):    Postfix
Summary(uk_UA.KOI8-U):    Postfix
Summary(pl): Proste statystyki dla Postfiksa

%define apache_group apache
%define maillog_group adm
%define mailgraph_user mailgraph
%define mailgraph_group mailgraph
%define mailgraph_cgi %_var/www/cgi-bin/%name
%define mailgraph_data %_localstatedir/%name

# should be looking whether /etc/init.d/functions-compat exists...
%if_with Master
  %define dist_tag Master
%endif

%if_with Sisyphus
  %define dist_tag Sisyphus
%endif

%if "%dist_tag" == ""
  %define dist_tag %(cut -d" " -f3 < /etc/altlinux-release)
%endif

%description
Mailgraph is a very simple mail statistics RRDtool frontend for
Postfix that produces daily, weekly, monthly and yearly graphs of
received/sent and bounced/rejected mail.

%description -l ru_RU.KOI8-R
Mailgraph --       -
Postfix,   RRDtool.   , ,
     /   
  .

%description -l uk_UA.KOI8-U
Mailgraph --       -̦
Postfix,  դ  RRDtool.   Ʀ  , ,
ͦ  Ҧ  Φ/צĦΦ  צԦ  Ҧ 
Ԧ.

%description -l pl
Mailgraph to prosty frontend na RRDtool do statystyk pocztowych dla
Postfiksa. Produkuje wykresy dzienne, tygodniowe, miesiczne i roczne
poczty wysanej/odebranej i odbitej/odrzuconej.

%prep
%if "%dist_tag" == ""
  echo "*** Unable to determine target distribution"
  echo "*** use --with Master or --with Sisyphus"
  exit 1
%endif
%setup	-q
%patch0 -p1

%install
%__subst "s,'mailgraph.cgi','index.cgi'," mailgraph.cgi

%__install -d %buildroot{%mailgraph_data/{tmp,imgs},%_var/run/mailgraph}
%__install -d %buildroot{%_sbindir,%_initdir,%mailgraph_cgi}
%__install -d %buildroot%_sysconfdir/httpd/conf/addon-modules

%__install mailgraph.cgi %buildroot%mailgraph_cgi/index.cgi
%__install mailgraph.pl %buildroot%_sbindir/mailgraph.pl

%__install %SOURCE1 %buildroot%_sysconfdir/httpd/conf/addon-modules/%name.conf
%__install %SOURCE2 %buildroot%mailgraph_cgi/.htaccess

%if "%dist_tag" == "Master"
  %__install %SOURCE3 %buildroot%_initdir/%name
%else
  %__install %SOURCE4 %buildroot%_initdir/%name
%endif

%pre
%_sbindir/groupadd -r -f %mailgraph_group 2>/dev/null ||:
%_sbindir/useradd -g %mailgraph_group -G %maillog_group \
	-c 'Mailgraph the Postfix Logfile Analyzer' \
	-d %mailgraph_data -s /dev/null -r %mailgraph_user \
	2>/dev/null ||:

%post
/sbin/chkconfig --add %name
if [ -f %_sysconfdir/httpd/conf/httpd.conf ] && \
   ! grep -q "^Include.*/%name.conf" %_sysconfdir/httpd/conf/httpd.conf; then
	echo "Include conf/addon-modules/%name.conf" \
		>> %_sysconfdir/httpd/conf/httpd.conf
	%_sbindir/apxs -e -a -n expires \
		%_libdir/apache/mod_expires.so
	%_initdir/httpd condrestart 1>&2
fi

if [ -f %_lockdir/subsys/%name ]; then
	%_initdir/%name restart 1>&2
else
	echo "Run \"%_initdir/%name start\" to start %name service."
	echo "NB: httpd-perl should be running for web output!"
fi

%preun
if [ "$1" = "0" ]; then
	grep -E -v "^Include.*%name.conf" %_sysconfdir/httpd/conf/httpd.conf \
		> %_sysconfdir/httpd/conf/httpd.conf.tmp
	mv -f %_sysconfdir/httpd/conf/httpd.conf.tmp \
		%_sysconfdir/httpd/conf/httpd.conf
	%_initdir/httpd restart 1>&2
	if [ -f %_lockdir/subsys/%name ]; then
		%_initdir/%name stop 1>&2
	fi
	/sbin/chkconfig --del %name
fi

%triggerpostun -- %name <= 1.2-alt1
# work around update problem caused by postun script deleting user/group
%_sbindir/groupadd -r -f %mailgraph_group 2>/dev/null ||:
%_sbindir/useradd -g %mailgraph_group -G %maillog_group \
	-c 'Mailgraph the Postfix Logfile Analyzer' \
	-d %mailgraph_data -s /dev/null -r %mailgraph_user \
	2>/dev/null ||:
find %_var/run/mailgraph %mailgraph_data %mailgraph_cgi -nouser -print0 \
	-exec chown %mailgraph_user -- \{\} \;

# TODO:
# - try again to let non-root webmaster edit the config file
# - migrate to better conf scheme with includes if/when it is
# - make use of apache rpm macros?
# - handle httpd vs httpd-perl somehow?
# - fix perms on %mailgraph_cgi (see spp.tex, #4.5)

%files
%_sbindir/mailgraph.pl
%_initdir/mailgraph
%attr(644,root,root) %config(noreplace) %verify(not size mtime md5) %_sysconfdir/httpd/conf/addon-modules/mailgraph.conf
%attr(751,%mailgraph_user,root) %dir %_var/run/mailgraph
%attr(711,%mailgraph_user,%apache_group) %dir %mailgraph_data
%attr(711,%mailgraph_user,%apache_group) %dir %mailgraph_data/imgs
%attr(770,%mailgraph_user,%apache_group) %dir %mailgraph_data/tmp
%attr(02750,%mailgraph_user,%apache_group) %dir %mailgraph_cgi
%attr(644,root,%apache_group) %config(noreplace) %mailgraph_cgi/.htaccess
%attr(550,%mailgraph_user,%apache_group) %mailgraph_cgi/index.cgi
%doc README CHANGES

%changelog
* Tue Apr 20 2004 Serge A. Volkov <vserge@altlinux.ru> 1.8-alt1
- Update to new version 1.8

* Fri Jan 30 2004 Michael Shigorin <mike@altlinux.ru> 1.6-alt1
- 1.6
- removed my silly {user,group}del from %%preun; new trigger :(
- auto-select Master/Sisyphus initscripts (not ideal though)
- added mod_expires activation
- BuildArch: noarch
- spec cleanup

* Wed Jun 11 2003 Nick Fedchik <nick@fedchik.org.ua> 1.3-alt1
- Updated sources to version 1.3
- Changed place of mailgraph.conf to /etc/httpd/conf/addon-modules
- Changed place of mailgraph.cgi to /var/www/cgi-bin/mailgraph
- Other minor fixes

* Tue Jun 10 2003 Michael Shigorin <mike@altlinux.ru> 1.2-alt2
- added empty %%mailgraph_data/mailgraph.rrd
- IfModule'ized mod_expire statements in mailgraph.conf
- thanks Nick Fedchik <nick at fedchik org ua> for reminding me :)

* Sun Mar 09 2003 Michael Shigorin <mike@altlinux.ru> 1.2-alt1
- built for ALT Linux
- spec adapted from PLD <feedback@pld.org.pl> (0.20)
  All persons listed below can be reached at <cvs_login>@pld.org.pl
  blues, grzegorz, kloczek, qboosh 
- heavy spec cleanup
- mailgraph.pl no longer runs as root
- access from localhost only by default
